searchData={"items":[{"type":"module","title":"Solana","doc":"A library for interacting with the Solana blockchain.","ref":"Solana.html"},{"type":"function","title":"Solana.bpf_loader/0","doc":"The public key for the [BPF Loader\nprogram](https://docs.solana.com/developing/runtime-facilities/programs#bpf-loader)","ref":"Solana.html#bpf_loader/0"},{"type":"function","title":"Solana.clock/0","doc":"The public key for the [Clock system\nvariable](https://docs.solana.com/developing/runtime-facilities/sysvars#clock)","ref":"Solana.html#clock/0"},{"type":"type","title":"Solana.key/0","doc":"See `t:Solana.Key.t/0`","ref":"Solana.html#t:key/0"},{"type":"function","title":"Solana.keypair/0","doc":"See `Solana.Key.pair/0`","ref":"Solana.html#keypair/0"},{"type":"type","title":"Solana.keypair/0","doc":"See `t:Solana.Key.pair/0`","ref":"Solana.html#t:keypair/0"},{"type":"function","title":"Solana.pubkey/1","doc":"Decodes or extracts a `t:Solana.Key.t/0` from a Base58-encoded string or a\n`t:Solana.Key.pair/0`.\n\nReturns `{:ok, key}` if the key is valid, or an error tuple if it's not.","ref":"Solana.html#pubkey/1"},{"type":"function","title":"Solana.pubkey!/1","doc":"Decodes or extracts a `t:Solana.Key.t/0` from a Base58-encoded string or a\n`t:Solana.Key.pair/0`.\n\nThrows an `ArgumentError` if it fails to retrieve the public key.","ref":"Solana.html#pubkey!/1"},{"type":"function","title":"Solana.recent_blockhashes/0","doc":"The public key for the [RecentBlockhashes system\nvariable](https://docs.solana.com/developing/runtime-facilities/sysvars#recentblockhashes)","ref":"Solana.html#recent_blockhashes/0"},{"type":"function","title":"Solana.rent/0","doc":"The public key for the [Rent system\nvariable](https://docs.solana.com/developing/runtime-facilities/sysvars#rent).","ref":"Solana.html#rent/0"},{"type":"module","title":"Solana.SPL.AssociatedToken","doc":"Functions for interacting with the [Associated Token Account\nProgram](https://spl.solana.com/associated-token-account).\n\nAn associated token account's address is derived from a user's main system\naccount and the token mint, which means each user can only have one associated\ntoken account per token.","ref":"Solana.SPL.AssociatedToken.html"},{"type":"function","title":"Solana.SPL.AssociatedToken.create_account/1","doc":"Creates an associated token account.\n\nThis will be owned by the `owner` regardless of who actually creates it.","ref":"Solana.SPL.AssociatedToken.html#create_account/1"},{"type":"function","title":"Options - Solana.SPL.AssociatedToken.create_account/1","doc":"* `:payer` - Required. The account which will pay for the `new` account's creation\n\n* `:owner` - Required. The account which will own the `new` account\n\n* `:new` - Required. Public key of the associated token account to create\n\n* `:mint` - Required. The mint of the `new` account","ref":"Solana.SPL.AssociatedToken.html#create_account/1-options"},{"type":"function","title":"Solana.SPL.AssociatedToken.create_account_idempotent/1","doc":"Creates an associated token account idempotently, ie it doesn't do anything if account is\nalready created.\n\nThis will be owned by the `owner` regardless of who actually creates it.","ref":"Solana.SPL.AssociatedToken.html#create_account_idempotent/1"},{"type":"function","title":"Options - Solana.SPL.AssociatedToken.create_account_idempotent/1","doc":"* `:payer` - Required. The account which will pay for the `new` account's creation\n\n* `:owner` - Required. The account which will own the `new` account\n\n* `:new` - Required. Public key of the associated token account to create\n\n* `:mint` - Required. The mint of the `new` account","ref":"Solana.SPL.AssociatedToken.html#create_account_idempotent/1-options"},{"type":"function","title":"Solana.SPL.AssociatedToken.find_address/2","doc":"Finds the token account address associated with a given owner and mint.\n\nThis address will be unique to the mint/owner combination.","ref":"Solana.SPL.AssociatedToken.html#find_address/2"},{"type":"function","title":"Solana.SPL.AssociatedToken.id/0","doc":"The Associated Token Account's Program ID","ref":"Solana.SPL.AssociatedToken.html#id/0"},{"type":"module","title":"Solana.SPL.Governance","doc":"Functions for interacting with the [SPL Governance\nprogram](https://github.com/solana-labs/solana-program-library/tree/master/governance#readme).\n\nThe governance program aims to provide core building blocks for creating\nDecentralized Autonomous Organizations (DAOs).","ref":"Solana.SPL.Governance.html"},{"type":"function","title":"Solana.SPL.Governance.add_signatory/1","doc":"Generates the instructions to add a `signatory` to the `proposal`.\n\nThis means that the `proposal` can't leave Draft state until this `signatory`\nsigns off on it.","ref":"Solana.SPL.Governance.html#add_signatory/1"},{"type":"function","title":"Options - Solana.SPL.Governance.add_signatory/1","doc":"* `:proposal` - Required. proposal account to add the `signatory` to.\n\n* `:signatory` - Required. the signatory to add to the `proposal`.\n\n* `:authority` - Required. Public key of the governance authority (or its delegate).\n\n* `:payer` - Required. The account which will pay for the new signatory record's creation.\n\n* `:owner_record` - Required. Public key of the `proposal` owner's Token Owner Record account.\n\n* `:program` - Required. Public key of the governance program instance to use.","ref":"Solana.SPL.Governance.html#add_signatory/1-options"},{"type":"function","title":"Solana.SPL.Governance.cancel_proposal/1","doc":"Generates the instructions to cancel the given `proposal`.","ref":"Solana.SPL.Governance.html#cancel_proposal/1"},{"type":"function","title":"Options - Solana.SPL.Governance.cancel_proposal/1","doc":"* `:governance` - Required. The governance account.\n\n* `:proposal` - Required. The proposal account.\n\n* `:owner_record` - Required. Public key of the `proposal` owner's Token Owner Record account.\n\n* `:authority` - Required. Public key of the governance authority (or its delegate).\n\n* `:program` - Required. Public key of the governance program instance to use.","ref":"Solana.SPL.Governance.html#cancel_proposal/1-options"},{"type":"function","title":"Solana.SPL.Governance.cast_vote/1","doc":"Generates the instructions for a token owner to cast a vote on the given\n`proposal`.\n\nBy doing so, the owner indicates they approve or disapprove of running the\n`proposal`'s set of instructions.\n\nIf this vote causes the proposal to reach a consensus, the instructions can be\nrun after the configured `delay`.","ref":"Solana.SPL.Governance.html#cast_vote/1"},{"type":"function","title":"Options - Solana.SPL.Governance.cast_vote/1","doc":"* `:realm` - Required. The realm account.\n\n* `:proposal` - Required. The proposal account.\n\n* `:governance` - Required. The governance account.\n\n* `:owner_record` - Required. Public key of the `proposal` owner's Token Owner Record account.\n\n* `:authority` - Required. Public key of the governance authority (or its delegate).\n\n* `:mint` - Required. The governing token mint.\n\n* `:payer` - Required. The account which will pay for the Vote Record account's creation.\n\n* `:voter_weight_record` - Public key of the voter weight record account.\n\n* `:max_voter_weight_record` - Public key of the max voter weight record account.\n\n* `:voter` - Required. Public key of the voter's governing token account.\n\n* `:vote` - Required. The user's vote. Passing an empty list indicates proposal rejection.\n\n* `:program` - Required. Public key of the governance program instance to use.","ref":"Solana.SPL.Governance.html#cast_vote/1-options"},{"type":"function","title":"Solana.SPL.Governance.create_account_governance/1","doc":"Generates instructions which create an Account Governance account, used to\ngovern an arbitrary account.","ref":"Solana.SPL.Governance.html#create_account_governance/1"},{"type":"function","title":"Options - Solana.SPL.Governance.create_account_governance/1","doc":"* `:payer` - Required. The account which will pay for the new Account Governance account's creation.\n\n* `:owner_record` - Required. The address of the governing Token Owner Record.\n\n* `:authority` - Required. Public key of the governance authority.\n\n* `:realm` - Required. Public key of the realm the created Governance belongs to.\n\n* `:governed` - Required. The account which will be goverened by the newly created governance.\n\n* `:program` - Required. Public key of the governance program instance to use.\n\n* `:voter_weight_record` - Public key of the voter weight record account.\n\n* `:max_voter_weight_record` - Public key of the max voter weight record account.\n\n* `:config` - Required. The desired governance configuration.","ref":"Solana.SPL.Governance.html#create_account_governance/1-options"},{"type":"function","title":"Options - Solana.SPL.Governance.create_account_governance/1","doc":"* `:threshold` - Required. The type of vote threshold used to resolve a Proposal vote.\n\n  * `:vote_weight_source` - The source of vote weight for voters. The default value is `:deposit`.\n\n  * `:minimum_community` (`t:non_neg_integer/0`) - The minimum number of community tokens an owner must have to create a proposal. The default value is `1`.\n\n  * `:minimum_council` (`t:non_neg_integer/0`) - The minimum number of council tokens an owner must have to create a proposal. The default value is `1`.\n\n  * `:duration` (`t:non_neg_integer/0`) - Required. Time limit (in seconds) for a proposal to be open for voting.\n\n  * `:cooldown` (`t:non_neg_integer/0`) - The time period (in seconds) within which a proposal can still be cancelled after voting has\n    ended. The default value is `0`.\n\n  * `:delay` (`t:non_neg_integer/0`) - Minimum wait time (in seconds) after a proposal has been voted on before an instruction can\n    be executed. The default value is `0`.","ref":"Solana.SPL.Governance.html#create_account_governance/1-options-1"},{"type":"function","title":"Solana.SPL.Governance.create_mint_governance/1","doc":"Generates instructions which create an Mint Governance account, used to\ngovern a token mint.","ref":"Solana.SPL.Governance.html#create_mint_governance/1"},{"type":"function","title":"Options - Solana.SPL.Governance.create_mint_governance/1","doc":"* `:payer` - Required. The account which will pay for the new Mint Governance account's creation.\n\n* `:owner_record` - Required. The address of the governing Token Owner Record.\n\n* `:authority` - Required. Public key of the governance authority.\n\n* `:realm` - Required. Public key of the realm the created Governance belongs to.\n\n* `:governed` - Required. The mint which will be goverened by the newly created governance.\n\n* `:mint_authority` - Required. The current mint authority of the `mint` to be governed.\n\n* `:program` - Required. Public key of the governance program instance to use.\n\n* `:voter_weight_record` - Public key of the voter weight record account.\n\n* `:max_voter_weight_record` - Public key of the max voter weight record account.\n\n* `:config` - Required. The desired governance configuration.","ref":"Solana.SPL.Governance.html#create_mint_governance/1-options"},{"type":"function","title":"Options - Solana.SPL.Governance.create_mint_governance/1","doc":"* `:threshold` - Required. The type of vote threshold used to resolve a Proposal vote.\n\n  * `:vote_weight_source` - The source of vote weight for voters. The default value is `:deposit`.\n\n  * `:minimum_community` (`t:non_neg_integer/0`) - The minimum number of community tokens an owner must have to create a proposal. The default value is `1`.\n\n  * `:minimum_council` (`t:non_neg_integer/0`) - The minimum number of council tokens an owner must have to create a proposal. The default value is `1`.\n\n  * `:duration` (`t:non_neg_integer/0`) - Required. Time limit (in seconds) for a proposal to be open for voting.\n\n  * `:cooldown` (`t:non_neg_integer/0`) - The time period (in seconds) within which a proposal can still be cancelled after voting has\n    ended. The default value is `0`.\n\n  * `:delay` (`t:non_neg_integer/0`) - Minimum wait time (in seconds) after a proposal has been voted on before an instruction can\n    be executed. The default value is `0`.\n\n* `:transfer_mint_authority?` (`t:boolean/0`) - Whether or not the `governed` mint's authority should be transferred to\n  the governance PDA. This can also be done later. The default value is `false`.","ref":"Solana.SPL.Governance.html#create_mint_governance/1-options-1"},{"type":"function","title":"Solana.SPL.Governance.create_native_treasury/1","doc":"Generates instructions to create a native SOL treasury account for a\nGovernance account.\n\nThe account has no data and can be used:\n\n- as a payer for instructions signed by governance PDAs\n- as a native SOL treasury","ref":"Solana.SPL.Governance.html#create_native_treasury/1"},{"type":"function","title":"Options - Solana.SPL.Governance.create_native_treasury/1","doc":"* `:governance` - Required. The governance account associated with the new treasury account.\n\n* `:payer` - Required. The account which will pay for the native treasury account's creation.\n\n* `:program` - Required. Public key of the governance program instance to use.","ref":"Solana.SPL.Governance.html#create_native_treasury/1-options"},{"type":"function","title":"Solana.SPL.Governance.create_owner_record/1","doc":"Generates instructions to create a Token Owner Record with no voter weight (0\ndeposit).\n\nThis is used to register a token owner when the Voter Weight Add-in is used\nand the Governance program doesn't take deposits.","ref":"Solana.SPL.Governance.html#create_owner_record/1"},{"type":"function","title":"Options - Solana.SPL.Governance.create_owner_record/1","doc":"* `:realm` - Required. The realm account.\n\n* `:owner` - Required. The governing token owner's account.\n\n* `:mint` - Required. The mint for the governing token.\n\n* `:payer` - Required. The account which will pay for the Token Owner Record account's creation.\n\n* `:program` - Required. Public key of the governance program instance to use.","ref":"Solana.SPL.Governance.html#create_owner_record/1-options"},{"type":"function","title":"Solana.SPL.Governance.create_program_governance/1","doc":"Generates instructions which create an Program Governance account, used to\ngovern an upgradable Solana program.","ref":"Solana.SPL.Governance.html#create_program_governance/1"},{"type":"function","title":"Options - Solana.SPL.Governance.create_program_governance/1","doc":"* `:payer` - Required. The account which will pay for the new Program Governance account's creation.\n\n* `:owner_record` - Required. The address of the governing Token Owner Record.\n\n* `:authority` - Required. Public key of the governance authority.\n\n* `:realm` - Required. Public key of the realm the created Governance belongs to.\n\n* `:governed` - Required. The program which will be goverened by the newly created governance.\n\n* `:upgrade_authority` - Required. The current upgrade authority of the `goverened` program.\n\n* `:program` - Required. Public key of the governance program instance to use.\n\n* `:voter_weight_record` - Public key of the voter weight record account.\n\n* `:max_voter_weight_record` - Public key of the max voter weight record account.\n\n* `:transfer_upgrade_authority?` (`t:boolean/0`) - Whether or not the `governed` program's upgrade authority should be\n  transferred to the governance PDA. This can also be done later. The default value is `false`.\n\n* `:config` - Required. The desired governance configuration.","ref":"Solana.SPL.Governance.html#create_program_governance/1-options"},{"type":"function","title":"Options - Solana.SPL.Governance.create_program_governance/1","doc":"* `:threshold` - Required. The type of vote threshold used to resolve a Proposal vote.\n\n  * `:vote_weight_source` - The source of vote weight for voters. The default value is `:deposit`.\n\n  * `:minimum_community` (`t:non_neg_integer/0`) - The minimum number of community tokens an owner must have to create a proposal. The default value is `1`.\n\n  * `:minimum_council` (`t:non_neg_integer/0`) - The minimum number of council tokens an owner must have to create a proposal. The default value is `1`.\n\n  * `:duration` (`t:non_neg_integer/0`) - Required. Time limit (in seconds) for a proposal to be open for voting.\n\n  * `:cooldown` (`t:non_neg_integer/0`) - The time period (in seconds) within which a proposal can still be cancelled after voting has\n    ended. The default value is `0`.\n\n  * `:delay` (`t:non_neg_integer/0`) - Minimum wait time (in seconds) after a proposal has been voted on before an instruction can\n    be executed. The default value is `0`.","ref":"Solana.SPL.Governance.html#create_program_governance/1-options-1"},{"type":"function","title":"Solana.SPL.Governance.create_proposal/1","doc":"Generates instructions which create a Proposal account.\n\nProposals allow governance token owners to propose governance changes (i.e.\ninstructions) to an account that will go into effect (i.e. be executed) at\nsome point in the future.","ref":"Solana.SPL.Governance.html#create_proposal/1"},{"type":"function","title":"Options - Solana.SPL.Governance.create_proposal/1","doc":"* `:payer` - Required. The account which will pay for the new Proposal account's creation.\n\n* `:owner` - Required. Public key of the token owner who is making the propsal.\n\n* `:authority` - Required. Public key of the governance authority.\n\n* `:mint` - Required. The governing token mint.\n\n* `:governance` - Required. The governance account for which this proposal is made.\n\n* `:realm` - Required. Public key of the realm the created Governance belongs to.\n\n* `:program` - Required. Public key of the governance program instance to use.\n\n* `:voter_weight_record` - Public key of the voter weight record account.\n\n* `:max_voter_weight_record` - Public key of the max voter weight record account.\n\n* `:name` (`t:String.t/0`) - Required. The proposal name.\n\n* `:description` (`t:String.t/0`) - Required. The proposal explanation.\n\n* `:vote_type` - Required. The proposal's vote type.\n\n* `:options` (list of `t:String.t/0`) - Required. Proposal options.\n\n* `:has_deny_option?` (`t:boolean/0`) - Indicates whether this proposal has a 'deny' option. Must be `true` if the\n  proposal wants to include executable instructions. The default value is `true`.\n\n* `:index` (`t:non_neg_integer/0`) - Required. The proposal index, i.e. this is the Nth proposal for this governance.","ref":"Solana.SPL.Governance.html#create_proposal/1-options"},{"type":"function","title":"Solana.SPL.Governance.create_realm/1","doc":"Generates instructions which create a new realm.","ref":"Solana.SPL.Governance.html#create_realm/1"},{"type":"function","title":"Options - Solana.SPL.Governance.create_realm/1","doc":"* `:payer` - Required. The account which will pay for the new realm account's creation.\n\n* `:authority` - Required. Public key of the authority account for the new realm.\n\n* `:community_mint` - Required. Community token mint for the new realm.\n\n* `:council_mint` - Community token mint for the new realm.\n\n* `:program` - Required. Public key of the governance program instance to use.\n\n* `:voter_weight_addin` - Community voter weight add-in program ID.\n\n* `:max_voter_weight_addin` - Max Community voter weight add-in program ID.\n\n* `:name` (`t:String.t/0`) - Required. The name of the new realm.\n\n* `:max_vote_weight_source` - Required. The source of max vote weight used for voting. Values below 100%\n  mint supply can be used when the governing token is fully minted but not\n  distributed yet.\n\n* `:minimum` (`t:non_neg_integer/0`) - Required. Minimum number of community tokens a user must hold to create a governance.","ref":"Solana.SPL.Governance.html#create_realm/1-options"},{"type":"function","title":"Solana.SPL.Governance.create_token_governance/1","doc":"Generates instructions which create a Token Governance account, used to\ngovern a token account.","ref":"Solana.SPL.Governance.html#create_token_governance/1"},{"type":"function","title":"Options - Solana.SPL.Governance.create_token_governance/1","doc":"* `:payer` - Required. The account which will pay for the new Token Governance account's creation.\n\n* `:owner_record` - Required. The address of the governing Token Owner Record.\n\n* `:authority` - Required. Public key of the governance authority.\n\n* `:realm` - Required. Public key of the realm the created Governance belongs to.\n\n* `:governed` - Required. The account which will be goverened by the newly created governance.\n\n* `:owner` - Required. The current owner of the `goverened` token account.\n\n* `:program` - Required. Public key of the governance program instance to use.\n\n* `:voter_weight_record` - Public key of the voter weight record account.\n\n* `:max_voter_weight_record` - Public key of the max voter weight record account.\n\n* `:config` - Required. The desired governance configuration.","ref":"Solana.SPL.Governance.html#create_token_governance/1-options"},{"type":"function","title":"Options - Solana.SPL.Governance.create_token_governance/1","doc":"* `:threshold` - Required. The type of vote threshold used to resolve a Proposal vote.\n\n  * `:vote_weight_source` - The source of vote weight for voters. The default value is `:deposit`.\n\n  * `:minimum_community` (`t:non_neg_integer/0`) - The minimum number of community tokens an owner must have to create a proposal. The default value is `1`.\n\n  * `:minimum_council` (`t:non_neg_integer/0`) - The minimum number of council tokens an owner must have to create a proposal. The default value is `1`.\n\n  * `:duration` (`t:non_neg_integer/0`) - Required. Time limit (in seconds) for a proposal to be open for voting.\n\n  * `:cooldown` (`t:non_neg_integer/0`) - The time period (in seconds) within which a proposal can still be cancelled after voting has\n    ended. The default value is `0`.\n\n  * `:delay` (`t:non_neg_integer/0`) - Minimum wait time (in seconds) after a proposal has been voted on before an instruction can\n    be executed. The default value is `0`.\n\n* `:transfer_ownership?` (`t:boolean/0`) - Whether or not the `governed` token's ownership should be transferred to\n  the governance PDA. This can also be done later. The default value is `false`.","ref":"Solana.SPL.Governance.html#create_token_governance/1-options-1"},{"type":"function","title":"Solana.SPL.Governance.delegate/1","doc":"Generates instructions which set the new governance delegate for an ownership\naccount within the given `realm` and `mint`.\n\nThe delegate can vote or create Proposals on behalf of the `owner`.\n\nNote: Delegating voting rights doesn't take them away from the original owner.","ref":"Solana.SPL.Governance.html#delegate/1"},{"type":"function","title":"Options - Solana.SPL.Governance.delegate/1","doc":"* `:owner` - Required. The current non-delegated holder of voting rights within the `realm`.\n\n* `:record` - Required. The Token Owner Record account for which the `owner` wishes to delegate rights.\n\n* `:to` - The account which will receive voter rights from the `owner` in the given\n  `realm`. **Not including this argument will rescind the current delegate's\n  voting rights.**\n\n* `:program` - Required. Public key of the governance program instance to use.","ref":"Solana.SPL.Governance.html#delegate/1-options"},{"type":"function","title":"Solana.SPL.Governance.deposit/1","doc":"Generates instructions which deposit governing tokens -- community or council\n-- to the given `realm`.\n\nThis establishes a user's voter weight to be used when voting within the\n`realm`.\n\nNote: If a subsequent (top up) deposit is made, the user's vote weights on\nactive proposals *won't* be updated automatically. To do this, the user must\nrelinquish their votes and vote again.","ref":"Solana.SPL.Governance.html#deposit/1"},{"type":"function","title":"Options - Solana.SPL.Governance.deposit/1","doc":"* `:owner` - Required. The `from` token account's owner.\n\n* `:authority` - Required. The `from` token account's transfer authority.\n\n* `:realm` - Required. Public key of the realm to deposit user tokens into.\n\n* `:mint` - Required. The mint for the token the user wishes to deposit.\n\n* `:from` - Required. The user's token account.\n\n* `:payer` - Required. The account which will pay to create the user's token owner record account\n  (if necessary).\n\n* `:amount` (`t:pos_integer/0`) - Required. The number of tokens to transfer.\n\n* `:program` - Required. Public key of the governance program instance to use.","ref":"Solana.SPL.Governance.html#deposit/1-options"},{"type":"function","title":"Solana.SPL.Governance.execute_instruction/1","doc":"Generates instructions to execute the instruction at index `index` in the\nproposal.\n\nAnybody can execute an instruction once the Proposal has been approved and the\ninstruction's `delay` time has passed.\n\nThe instruction being executed will be signed by the Governance PDA the\nproposal belongs to, e.g. the Program Governance PDA for program upgrade\ninstructions.","ref":"Solana.SPL.Governance.html#execute_instruction/1"},{"type":"function","title":"Options - Solana.SPL.Governance.execute_instruction/1","doc":"* `:proposal` - Required. The proposal account.\n\n* `:instruction` - Required. The Proposal Instruction account containing the instruction to execute.\n\n* `:accounts` - Any extra accounts that are part of the instruction, in order.\n\n* `:program` - Required. Public key of the governance program instance to use.","ref":"Solana.SPL.Governance.html#execute_instruction/1-options"},{"type":"function","title":"Solana.SPL.Governance.finalize_vote/1","doc":"Generates instructions to finalize a vote.\n\nThis is available in case the vote was not automatically tipped with the\nproposal's `duration`.","ref":"Solana.SPL.Governance.html#finalize_vote/1"},{"type":"function","title":"Options - Solana.SPL.Governance.finalize_vote/1","doc":"* `:realm` - Required. The realm account.\n\n* `:proposal` - Required. The proposal account.\n\n* `:governance` - Required. The governance account.\n\n* `:owner_record` - Required. Public key of the `proposal` owner's Token Owner Record account.\n\n* `:mint` - Required. The governing token mint.\n\n* `:program` - Required. Public key of the governance program instance to use.","ref":"Solana.SPL.Governance.html#finalize_vote/1-options"},{"type":"function","title":"Solana.SPL.Governance.find_account_governance_address/3","doc":"Finds the account governance address for the given `realm` and `account`.\nShould have the seeds: `[\"account-governance\", realm, account]`.","ref":"Solana.SPL.Governance.html#find_account_governance_address/3"},{"type":"function","title":"Solana.SPL.Governance.find_holding_address/3","doc":"Finds a token holding address for the given community/council `mint`. Should\nhave the seeds: `[\"governance\", realm, mint]`.","ref":"Solana.SPL.Governance.html#find_holding_address/3"},{"type":"function","title":"Solana.SPL.Governance.find_metadata_address/1","doc":"Finds the program metadata address for the given governance program. Should\nhave the seeds: `[\"metadata\"]`","ref":"Solana.SPL.Governance.html#find_metadata_address/1"},{"type":"function","title":"Solana.SPL.Governance.find_mint_governance_address/3","doc":"Finds the mint governance address for the given `realm` and `mint`.\nShould have the seeds: `[\"mint-governance\", realm, mint]`.","ref":"Solana.SPL.Governance.html#find_mint_governance_address/3"},{"type":"function","title":"Solana.SPL.Governance.find_native_treasury_address/2","doc":"Finds the native SOL treasury address for the given `governance` account.\nShould have the seeds: `[\"treasury\", governance]`","ref":"Solana.SPL.Governance.html#find_native_treasury_address/2"},{"type":"function","title":"Solana.SPL.Governance.find_owner_record_address/4","doc":"Finds the token owner record address for the given `realm`, `mint`, and\n`owner`. Should have the seeds: `[\"governance\", realm, mint, owner]`.","ref":"Solana.SPL.Governance.html#find_owner_record_address/4"},{"type":"function","title":"Solana.SPL.Governance.find_program_governance_address/3","doc":"Finds the program governance address for the given `realm` and `governed`\nprogram. Should have the seeds: `[\"program-governance\", realm, governed]`.","ref":"Solana.SPL.Governance.html#find_program_governance_address/3"},{"type":"function","title":"Solana.SPL.Governance.find_proposal_address/4","doc":"Finds the `governance` proposal address for the given `mint` and `index`.\nShould have the seeds: `[\"governance\", governance, mint, index]`.","ref":"Solana.SPL.Governance.html#find_proposal_address/4"},{"type":"function","title":"Solana.SPL.Governance.find_realm_address/2","doc":"Finds the realm address for the given `name`. Should have the seeds `[\"governance\", name]`","ref":"Solana.SPL.Governance.html#find_realm_address/2"},{"type":"function","title":"Solana.SPL.Governance.find_realm_config_address/2","doc":"Finds the realm config address for the given `realm`. Should have the seeds:\n`[\"realm-config\", realm]`.","ref":"Solana.SPL.Governance.html#find_realm_config_address/2"},{"type":"function","title":"Solana.SPL.Governance.find_signatory_record_address/3","doc":"Finds the `proposal`'s `signatory` record address. Should have the seeds:\n`[\"governance\", proposal, signatory]`.","ref":"Solana.SPL.Governance.html#find_signatory_record_address/3"},{"type":"function","title":"Solana.SPL.Governance.find_token_governance_address/3","doc":"Finds the token governance address for the given `realm` and `token`.\nShould have the seeds: `[\"token-governance\", realm, token]`.","ref":"Solana.SPL.Governance.html#find_token_governance_address/3"},{"type":"function","title":"Solana.SPL.Governance.find_transaction_address/4","doc":"Finds the `proposal`'s transaction address for the given `option` and `index`.\nShould have the seeds: `[\"governance\", proposal, option, index]`.","ref":"Solana.SPL.Governance.html#find_transaction_address/4"},{"type":"function","title":"Solana.SPL.Governance.find_vote_record_address/3","doc":"Finds the vote record address for the given `proposal` and `owner_record`.\nShould have the seeds: `[\"governance\", proposal, owner_record]`.","ref":"Solana.SPL.Governance.html#find_vote_record_address/3"},{"type":"function","title":"Solana.SPL.Governance.flag_instruction_error/1","doc":"Flag an instruction and its parent proposal with \"error\" status.","ref":"Solana.SPL.Governance.html#flag_instruction_error/1"},{"type":"function","title":"Options - Solana.SPL.Governance.flag_instruction_error/1","doc":"* `:proposal` - Required. The proposal account.\n\n* `:instruction` - Required. The Proposal Instruction account to flag.\n\n* `:authority` - Required. Public key of the governance authority (or its delegate).\n\n* `:owner_record` - Required. Public key of the `proposal` owner's Token Owner Record account.\n\n* `:program` - Required. Public key of the governance program instance to use.","ref":"Solana.SPL.Governance.html#flag_instruction_error/1-options"},{"type":"function","title":"Solana.SPL.Governance.id/0","doc":"The Governance program's default instance ID. Organizations can also deploy\ntheir own custom instance if they wish.","ref":"Solana.SPL.Governance.html#id/0"},{"type":"function","title":"Solana.SPL.Governance.insert_transaction/1","doc":"Generates the instructions to insert a transaction into the proposal at the\ngiven `index`.\n\nNew transactions must be inserted at the end of the range indicated by the\nproposal's `transaction_next_index` property. If a transaction replaces an\nexisting transaction at a given `index`, the old one must first be removed by\ncalling `Solana.SPL.Governance.remove_transaction/1`.","ref":"Solana.SPL.Governance.html#insert_transaction/1"},{"type":"function","title":"Options - Solana.SPL.Governance.insert_transaction/1","doc":"* `:governance` - Required. The governance account.\n\n* `:proposal` - Required. The proposal account.\n\n* `:owner_record` - Required. Public key of the `proposal` owner's Token Owner Record account.\n\n* `:authority` - Required. Public key of the governance authority (or its delegate).\n\n* `:payer` - Required. The account which will pay for the Proposal Instruction account's creation.\n\n* `:option` (`t:non_neg_integer/0`) - The index of the option the instruction is for. The default value is `0`.\n\n* `:index` (`t:non_neg_integer/0`) - Required. The index where the `instruction` will be inserted.\n\n* `:delay` (`t:non_neg_integer/0`) - Wait time (in seconds) between the vote period ending and the\n  `instruction` being eligible for execution. The default value is `0`.\n\n* `:instructions` - Required. Data for the instructions to be executed\n\n* `:program` - Required. Public key of the governance program instance to use.","ref":"Solana.SPL.Governance.html#insert_transaction/1-options"},{"type":"function","title":"Solana.SPL.Governance.relinquish_vote/1","doc":"Generates instructions to relinquish a voter's vote from a proposal.\n\nIf the proposal is still being voted on, the voter's weight won't count toward\nthe outcome. If the proposal is already decided, this instruction has no\neffect on the proposal, but allows voters to prune their outstanding votes in\ncase they want to withdraw governing tokens from the realm.","ref":"Solana.SPL.Governance.html#relinquish_vote/1"},{"type":"function","title":"Options - Solana.SPL.Governance.relinquish_vote/1","doc":"* `:proposal` - Required. The proposal account.\n\n* `:governance` - Required. The governance account.\n\n* `:owner_record` - Required. Public key of the voter's governing Token Owner Record.\n\n* `:mint` - Required. The governing token mint.\n\n* `:authority` - Public key of the governance authority (or its delegate). Only required if\n  the proposal is still being voted on.\n\n* `:beneficiary` - Public key of the account to receive the disposed vote record account's\n  lamports. Only required if the proposal is still being voted on.\n\n* `:program` - Required. Public key of the governance program instance to use.","ref":"Solana.SPL.Governance.html#relinquish_vote/1-options"},{"type":"function","title":"Solana.SPL.Governance.remove_signatory/1","doc":"Generates the instructions to remove a `signatory` from the `proposal`.","ref":"Solana.SPL.Governance.html#remove_signatory/1"},{"type":"function","title":"Options - Solana.SPL.Governance.remove_signatory/1","doc":"* `:proposal` - Required. proposal account to add the `signatory` to.\n\n* `:signatory` - Required. the signatory to add to the `proposal`.\n\n* `:authority` - Required. Public key of the governance authority (or its delegate).\n\n* `:owner_record` - Required. Public key of the `proposal` owner's Token Owner Record account.\n\n* `:beneficiary` - Required. Public key of the account to receive the disposed signatory record account's lamports.\n\n* `:program` - Required. Public key of the governance program instance to use.","ref":"Solana.SPL.Governance.html#remove_signatory/1-options"},{"type":"function","title":"Solana.SPL.Governance.remove_transaction/1","doc":"Generates the instructions to remove the Transaction data at the given `index`\nfrom the given `proposal`.","ref":"Solana.SPL.Governance.html#remove_transaction/1"},{"type":"function","title":"Options - Solana.SPL.Governance.remove_transaction/1","doc":"* `:proposal` - Required. The proposal account.\n\n* `:owner_record` - Required. Public key of the `proposal` owner's Token Owner Record account.\n\n* `:authority` - Required. Public key of the governance authority (or its delegate).\n\n* `:beneficiary` - Required. Public key of the account to receive the disposed instruction account's lamports.\n\n* `:transaction` - Required. The Proposal Transaction account indicating the transaction to remove.\n\n* `:program` - Required. Public key of the governance program instance to use.","ref":"Solana.SPL.Governance.html#remove_transaction/1-options"},{"type":"function","title":"Solana.SPL.Governance.set_governance_config/1","doc":"Generates the instructions to set a governance's config.","ref":"Solana.SPL.Governance.html#set_governance_config/1"},{"type":"function","title":"Options - Solana.SPL.Governance.set_governance_config/1","doc":"* `:realm` - Required. The realm account the `governance` belongs to.\n\n* `:governance` - Required. The governance account to receive the new `config`.\n\n* `:config` - Required. The desired governance configuration.","ref":"Solana.SPL.Governance.html#set_governance_config/1-options"},{"type":"function","title":"Options - Solana.SPL.Governance.set_governance_config/1","doc":"* `:threshold` - Required. The type of vote threshold used to resolve a Proposal vote.\n\n  * `:vote_weight_source` - The source of vote weight for voters. The default value is `:deposit`.\n\n  * `:minimum_community` (`t:non_neg_integer/0`) - The minimum number of community tokens an owner must have to create a proposal. The default value is `1`.\n\n  * `:minimum_council` (`t:non_neg_integer/0`) - The minimum number of council tokens an owner must have to create a proposal. The default value is `1`.\n\n  * `:duration` (`t:non_neg_integer/0`) - Required. Time limit (in seconds) for a proposal to be open for voting.\n\n  * `:cooldown` (`t:non_neg_integer/0`) - The time period (in seconds) within which a proposal can still be cancelled after voting has\n    ended. The default value is `0`.\n\n  * `:delay` (`t:non_neg_integer/0`) - Minimum wait time (in seconds) after a proposal has been voted on before an instruction can\n    be executed. The default value is `0`.\n\n* `:program` - Required. Public key of the governance program instance to use.","ref":"Solana.SPL.Governance.html#set_governance_config/1-options-1"},{"type":"function","title":"Solana.SPL.Governance.set_realm_authority/1","doc":"Generates the instructions to set a new realm authority.","ref":"Solana.SPL.Governance.html#set_realm_authority/1"},{"type":"function","title":"Options - Solana.SPL.Governance.set_realm_authority/1","doc":"* `:realm` - Required. The realm account to assign a new authority.\n\n* `:current` - Required. The current realm authority.\n\n* `:new` - The new realm authority. Must be one of the realm governances.\n\n* `:program` - Required. Public key of the governance program instance to use.\n\n* `:action` - Required. The action to apply to the current realm authority. `:set` sets the new\n  realm authority without checks, `:set_checked` makes sure the new\n  authority is one of the realm's governances, and `:remove` removes the\n  realm authority.","ref":"Solana.SPL.Governance.html#set_realm_authority/1-options"},{"type":"function","title":"Solana.SPL.Governance.set_realm_config/1","doc":"Generates instructions to set the realm config.","ref":"Solana.SPL.Governance.html#set_realm_config/1"},{"type":"function","title":"Options - Solana.SPL.Governance.set_realm_config/1","doc":"* `:realm` - Required. The realm account.\n\n* `:authority` - Required. The realm authority.\n\n* `:council_mint` - The realm's council token mint.\n\n* `:payer` - The account which will pay for the Realm Config account's creation.\n\n* `:voter_weight_addin` - Community voter weight add-in program ID.\n\n* `:max_voter_weight_addin` - Max Community voter weight add-in program ID.\n\n* `:program` - Required. Public key of the governance program instance to use.\n\n* `:max_vote_weight_source` - Required. The source of max vote weight used for voting. Values below 100%\n  mint supply can be used when the governing token is fully minted but not\n  distributed yet.\n\n* `:minimum` (`t:non_neg_integer/0`) - Required. Minimum number of community tokens a user must hold to create a governance.","ref":"Solana.SPL.Governance.html#set_realm_config/1-options"},{"type":"function","title":"Solana.SPL.Governance.sign_off_proposal/1","doc":"Generates the instructions for a `signatory` to sign off on a `proposal`.\n\nThis indicates the `signatory` approves of the `proposal`. When the last\n`signatory` signs off, the `proposal` moves to the Voting state.","ref":"Solana.SPL.Governance.html#sign_off_proposal/1"},{"type":"function","title":"Options - Solana.SPL.Governance.sign_off_proposal/1","doc":"* `:proposal` - Required. The proposal account.\n\n* `:signatory` - Required. the signatory signing off on the `proposal`.\n\n* `:program` - Required. Public key of the governance program instance to use.","ref":"Solana.SPL.Governance.html#sign_off_proposal/1-options"},{"type":"function","title":"Solana.SPL.Governance.test_id/0","doc":"The governance program's test instance ID. This can be used to set up test DAOs.","ref":"Solana.SPL.Governance.html#test_id/0"},{"type":"function","title":"Solana.SPL.Governance.update_program_metadata/1","doc":"Generates instructions to update a Program Metadata account.\n\nThis dumps information implied by the governance program's code into a\npersistent account.","ref":"Solana.SPL.Governance.html#update_program_metadata/1"},{"type":"function","title":"Options - Solana.SPL.Governance.update_program_metadata/1","doc":"* `:payer` - Required. The account which will pay for the Program Metadata account's creation.\n\n* `:program` - Required. Public key of the governance program instance to use.","ref":"Solana.SPL.Governance.html#update_program_metadata/1-options"},{"type":"function","title":"Solana.SPL.Governance.withdraw/1","doc":"Generates instructions which withdraw governing tokens -- community or council\n-- from the given `realm`.\n\nThis downgrades a user's voter weight within the `realm`.\n\nNote: It's only possible to withdraw tokens if the user doesn't have any\noutstanding active votes. Otherwise, the user needs to relinquish those\nvotes before withdrawing their tokens.","ref":"Solana.SPL.Governance.html#withdraw/1"},{"type":"function","title":"Options - Solana.SPL.Governance.withdraw/1","doc":"* `:owner` - Required. The `to` token account's owner.\n\n* `:realm` - Required. Public key of the realm to withdraw governance tokens from.\n\n* `:mint` - Required. The mint for the token the user wishes to withdraw.\n\n* `:to` - Required. The user's token account. All tokens will be transferred to this account.\n\n* `:program` - Required. Public key of the governance program instance to use.","ref":"Solana.SPL.Governance.html#withdraw/1-options"},{"type":"module","title":"Solana.SPL.Token","doc":"Functions for interacting with Solana's [Token\nProgram](https://spl.solana.com/token).","ref":"Solana.SPL.Token.html"},{"type":"function","title":"Solana.SPL.Token.approve/1","doc":"Creates an instruction to approves a delegate.\n\nA delegate is given the authority over tokens on behalf of the source\naccount's owner.\n\nIf you want to check the token's `mint` and `decimals`, set the `checked?`\noption to `true` and provide the `mint` and `decimals` options.","ref":"Solana.SPL.Token.html#approve/1"},{"type":"function","title":"Options - Solana.SPL.Token.approve/1","doc":"* `:source` - Required. The account to send tokens from\n\n* `:delegate` - Required. The account authorized to perform a transfer of tokens from `source`\n\n* `:owner` - Required. The account which owns `source`\n\n* `:multi_signers` - signing accounts if the `owner` is a `Solana.SPL.Token.MultiSig` account\n\n* `:amount` (`t:pos_integer/0`) - Required. The maximum number of tokens that `delegate` can send on behalf of `source`\n\n* `:checked?` (`t:boolean/0`) - whether or not to check the token mint and decimals; may be useful\n    when creating transactions offline or within a hardware wallet. The default value is `false`.\n\n* `:decimals` - The number of decimals in the `amount`. Only used if `checked?` is true.\n\n* `:mint` - The mint account for `from` and `to`. Only used if `checked?` is true.","ref":"Solana.SPL.Token.html#approve/1-options"},{"type":"function","title":"Solana.SPL.Token.burn/1","doc":"Creates an instruction to burn tokens by removing them from an account.\n\n`burn/1` does not support accounts associated with the native mint, use\n`close_account/1` instead.\n\nIf you want to check the token's `mint` and `decimals`, set the `checked?`\noption to `true` and provide the `decimals` option.","ref":"Solana.SPL.Token.html#burn/1"},{"type":"function","title":"Options - Solana.SPL.Token.burn/1","doc":"* `:token` - Required. The token account which will have its tokens burned\n\n* `:mint` - Required. The mint account which will burn the tokens\n\n* `:owner` - Required. the owner of `token`\n\n* `:amount` (`t:pos_integer/0`) - Required. amount of tokens to burn\n\n* `:multi_signers` - signing accounts if the `owner` is a `Solana.SPL.Token.MultiSig` account\n\n* `:checked?` (`t:boolean/0`) - whether or not to check the token mint and decimals; may be useful\n    when creating transactions offline or within a hardware wallet. The default value is `false`.\n\n* `:decimals` - The number of decimals in the `amount`. Only used if `checked?` is true.","ref":"Solana.SPL.Token.html#burn/1-options"},{"type":"function","title":"Solana.SPL.Token.byte_size/0","doc":"The size of a serialized token account.","ref":"Solana.SPL.Token.html#byte_size/0"},{"type":"function","title":"Solana.SPL.Token.close_account/1","doc":"Creates an instruction to close an account by transferring all its SOL to the\n`destination` account.\n\nA non-native account may only be closed if its token amount is zero.","ref":"Solana.SPL.Token.html#close_account/1"},{"type":"function","title":"Options - Solana.SPL.Token.close_account/1","doc":"* `:to_close` - Required. The account to close\n\n* `:destination` - Required. The account which will receive the remaining balance of `to_close`\n\n* `:authority` - Required. the `account close` authority for `to_close`\n\n* `:multi_signers` - signing accounts if the `authority` is a `Solana.SPL.Token.MultiSig` account","ref":"Solana.SPL.Token.html#close_account/1-options"},{"type":"function","title":"Solana.SPL.Token.freeze/1","doc":"Creates an instruction to freeze an initialized account using the mint's\n`freeze_authority` (if set).","ref":"Solana.SPL.Token.html#freeze/1"},{"type":"function","title":"Options - Solana.SPL.Token.freeze/1","doc":"* `:to_freeze` - Required. The account to freeze\n\n* `:mint` - Required. The mint account for `to_freeze`\n\n* `:authority` - Required. the `freeze` authority for `mint`\n\n* `:multi_signers` - signing accounts if the `authority` is a `Solana.SPL.Token.MultiSig` account","ref":"Solana.SPL.Token.html#freeze/1-options"},{"type":"function","title":"Solana.SPL.Token.from_account_info/1","doc":"Translates the result of a `Solana.RPC.Request.get_account_info/2` into a\n`t:Solana.SPL.Token.t/0`.","ref":"Solana.SPL.Token.html#from_account_info/1"},{"type":"function","title":"Solana.SPL.Token.id/0","doc":"The Token Program's ID.","ref":"Solana.SPL.Token.html#id/0"},{"type":"function","title":"Solana.SPL.Token.init/1","doc":"Creates the instructions which initialize a new account to hold tokens.\n\nIf this account is associated with the native mint then the token balance of\nthe initialized account will be equal to the amount of SOL in the account. If\nthis account is associated with another mint, that mint must be initialized\nbefore this command can succeed.\n\nAll instructions must be executed as part of the same transaction. Otherwise\nanother party can acquire ownership of the uninitialized account.","ref":"Solana.SPL.Token.html#init/1"},{"type":"function","title":"Options - Solana.SPL.Token.init/1","doc":"* `:payer` - Required. The account that will pay for the token account creation\n\n* `:balance` (`t:non_neg_integer/0`) - Required. The lamport balance the token account should have\n\n* `:mint` - Required. The mint of the newly-created token account\n\n* `:owner` - Required. The owner of the newly-created token account\n\n* `:new` - Required. The public key of the newly-created token account","ref":"Solana.SPL.Token.html#init/1-options"},{"type":"function","title":"Solana.SPL.Token.mint_to/1","doc":"Creates an instruction to mints new tokens to an account.\n\nThe native mint does not support minting.\n\nIf you want to check the token's `mint` and `decimals`, set the `checked?`\noption to `true` and provide the `decimals` option.","ref":"Solana.SPL.Token.html#mint_to/1"},{"type":"function","title":"Options - Solana.SPL.Token.mint_to/1","doc":"* `:token` - Required. The token account which will receive the minted tokens\n\n* `:mint` - Required. The mint account which will mint the tokens\n\n* `:authority` - Required. the current mint authority\n\n* `:amount` (`t:pos_integer/0`) - Required. amount of tokens to mint\n\n* `:multi_signers` - signing accounts if the `authority` is a `Solana.SPL.Token.MultiSig` account\n\n* `:checked?` (`t:boolean/0`) - whether or not to check the token mint and decimals; may be useful\n    when creating transactions offline or within a hardware wallet. The default value is `false`.\n\n* `:decimals` - The number of decimals in the `amount`. Only used if `checked?` is true.","ref":"Solana.SPL.Token.html#mint_to/1-options"},{"type":"function","title":"Solana.SPL.Token.revoke/1","doc":"Creates an instruction to revoke a previously approved delegate's authority to\nmake transfers.","ref":"Solana.SPL.Token.html#revoke/1"},{"type":"function","title":"Options - Solana.SPL.Token.revoke/1","doc":"* `:source` - Required. The account to send tokens from\n\n* `:owner` - Required. The account which owns `source`\n\n* `:multi_signers` - signing accounts if the `owner` is a `Solana.SPL.Token.MultiSig` account","ref":"Solana.SPL.Token.html#revoke/1-options"},{"type":"function","title":"Solana.SPL.Token.set_authority/1","doc":"Creates an instruction to set a new authority for a mint or account.","ref":"Solana.SPL.Token.html#set_authority/1"},{"type":"function","title":"Options - Solana.SPL.Token.set_authority/1","doc":"* `:account` - Required. The account which will change authority, either a mint or token account\n\n* `:authority` - Required. the current authority for `mint_or_token`\n\n* `:new_authority` - the new authority for `mint_or_token`\n\n* `:type` - Required. type of authority to set\n\n* `:multi_signers` - signing accounts if the `authority` is a `Solana.SPL.Token.MultiSig` account","ref":"Solana.SPL.Token.html#set_authority/1-options"},{"type":"type","title":"Solana.SPL.Token.t/0","doc":"Token account metadata.","ref":"Solana.SPL.Token.html#t:t/0"},{"type":"function","title":"Solana.SPL.Token.thaw/1","doc":"Creates an instruction to thaw a frozen account using the mint's\n`freeze_authority` (if set).","ref":"Solana.SPL.Token.html#thaw/1"},{"type":"function","title":"Options - Solana.SPL.Token.thaw/1","doc":"* `:to_thaw` - Required. The account to thaw\n\n* `:mint` - Required. The mint account for `to_thaw`\n\n* `:authority` - Required. the `freeze` authority for `mint`\n\n* `:multi_signers` - signing accounts if the `authority` is a `Solana.SPL.Token.MultiSig` account","ref":"Solana.SPL.Token.html#thaw/1-options"},{"type":"function","title":"Solana.SPL.Token.transfer/1","doc":"Creates an instruction to transfer tokens from one account to another either\ndirectly or via a delegate.\n\nIf this account is associated with the native mint then equal amounts of SOL\nand Tokens will be transferred to the destination account.\n\nIf you want to check the token's `mint` and `decimals`, set the `checked?`\noption to `true` and provide the `mint` and `decimals` options.","ref":"Solana.SPL.Token.html#transfer/1"},{"type":"function","title":"Options - Solana.SPL.Token.transfer/1","doc":"* `:from` - Required. The account to send tokens from\n\n* `:to` - Required. The account to receive tokens\n\n* `:owner` - Required. The owner of `from`\n\n* `:multi_signers` - signing accounts if the `owner` is a `Solana.SPL.Token.MultiSig` account\n\n* `:amount` (`t:pos_integer/0`) - Required. The number of tokens to send\n\n* `:checked?` (`t:boolean/0`) - whether or not to check the token mint and decimals; may be useful\n  when creating transactions offline or within a hardware wallet. The default value is `false`.\n\n* `:decimals` - The number of decimals in the `amount`. Only used if `checked?` is true.\n\n* `:mint` - The mint account for `from` and `to`. Only used if `checked?` is true.","ref":"Solana.SPL.Token.html#transfer/1-options"},{"type":"module","title":"Solana.SPL.Token.Mint","doc":"Functions for interacting with the mint accounts of Solana's [Token\nProgram](https://spl.solana.com/token).","ref":"Solana.SPL.Token.Mint.html"},{"type":"function","title":"Solana.SPL.Token.Mint.byte_size/0","doc":"The size of a serialized token mint account.","ref":"Solana.SPL.Token.Mint.html#byte_size/0"},{"type":"function","title":"Solana.SPL.Token.Mint.from_account_info/1","doc":"Translates the result of a `Solana.RPC.Request.get_account_info/2` into a\n`t:Solana.SPL.Token.Mint.t/0`.","ref":"Solana.SPL.Token.Mint.html#from_account_info/1"},{"type":"function","title":"Solana.SPL.Token.Mint.init/1","doc":"Genereates the instructions to initialize a mint account.","ref":"Solana.SPL.Token.Mint.html#init/1"},{"type":"function","title":"Options - Solana.SPL.Token.Mint.init/1","doc":"* `:payer` - Required. The account that will pay for the mint creation\n\n* `:balance` (`t:non_neg_integer/0`) - Required. The lamport balance the mint account should have\n\n* `:decimals` - Required. decimals for the new mint\n\n* `:authority` - Required. authority for the new mint\n\n* `:freeze_authority` - freeze authority for the new mint\n\n* `:new` - Required. public key for the new mint","ref":"Solana.SPL.Token.Mint.html#init/1-options"},{"type":"type","title":"Solana.SPL.Token.Mint.t/0","doc":"Token Program mint account metadata.","ref":"Solana.SPL.Token.Mint.html#t:t/0"},{"type":"module","title":"Solana.SPL.Token.MultiSig","doc":"Functions for dealing with multi-signature accounts.\n\nMulti-signature accounts can used in place of any single owner/delegate\naccounts in any token instruction that require an owner/delegate to be\npresent.","ref":"Solana.SPL.Token.MultiSig.html"},{"type":"function","title":"Solana.SPL.Token.MultiSig.byte_size/0","doc":"The size of a serialized multi-signature account.","ref":"Solana.SPL.Token.MultiSig.html#byte_size/0"},{"type":"function","title":"Solana.SPL.Token.MultiSig.from_account_info/1","doc":"Translates the result of a `Solana.RPC.Request.get_account_info/2` into a\n`t:Solana.SPL.Token.MultiSig.t/0`.","ref":"Solana.SPL.Token.MultiSig.html#from_account_info/1"},{"type":"function","title":"Solana.SPL.Token.MultiSig.init/1","doc":"Creates the instructions to initialize a multisignature account.\n\n**These instructions must be included in the same Transaction.**","ref":"Solana.SPL.Token.MultiSig.html#init/1"},{"type":"function","title":"Options - Solana.SPL.Token.MultiSig.init/1","doc":"* `:payer` - Required. The account that will pay for the multisig creation\n\n* `:balance` (`t:non_neg_integer/0`) - Required. The lamport balance the multisig account should have\n\n* `:signers` - Required. The full set of signers; should be a list of 11 members or fewer\n\n* `:signatures_required` - Required. number of signatures required; should be between 1 and 11 (inclusive)\n\n* `:new` - Required. public key for the new multisig account","ref":"Solana.SPL.Token.MultiSig.html#init/1-options"},{"type":"type","title":"Solana.SPL.Token.MultiSig.t/0","doc":"Multi-signature account metadata.","ref":"Solana.SPL.Token.MultiSig.html#t:t/0"},{"type":"module","title":"Solana.SPL.TokenSwap","doc":"Functions for interacting with Solana's [Token Swap\nProgram](https://spl.solana.com/token-swap).","ref":"Solana.SPL.TokenSwap.html"},{"type":"function","title":"Solana.SPL.TokenSwap.byte_size/0","doc":"The size of a serialized token swap account.","ref":"Solana.SPL.TokenSwap.html#byte_size/0"},{"type":"function","title":"Solana.SPL.TokenSwap.deposit/1","doc":"Creates the instructions to deposit `A` or `B` tokens into the pool.","ref":"Solana.SPL.TokenSwap.html#deposit/1"},{"type":"function","title":"Options - Solana.SPL.TokenSwap.deposit/1","doc":"* `:swap` - Required. The token swap to use.\n\n* `:authority` - Required. the `swap` account's swap authority.\n\n* `:user_token` - Required. The user's account for token `A` or `B`.\n\n* `:swap_a` - Required. The `swap` account for token `A`.\n\n* `:swap_b` - Required. The `swap` account for token `B`.\n\n* `:user_pool` - Required. The user's account for the pool token. Pool tokens will be deposited here.\n\n* `:pool_mint` - Required. The `swap` pool token's mint.\n\n* `:user_authority` - Required. Account delegated to transfer the user's tokens.\n\n* `:amount` (`t:pos_integer/0`) - Required. Amount of token `A` or `B` to deposit.\n\n* `:amount_pool` (`t:pos_integer/0`) - Required. Minimum amount of pool tokens to mint.","ref":"Solana.SPL.TokenSwap.html#deposit/1-options"},{"type":"function","title":"Solana.SPL.TokenSwap.deposit_all/1","doc":"Creates the instructions to deposit both `A` and `B` tokens into the pool.","ref":"Solana.SPL.TokenSwap.html#deposit_all/1"},{"type":"function","title":"Options - Solana.SPL.TokenSwap.deposit_all/1","doc":"* `:swap` - Required. The token swap to use.\n\n* `:authority` - Required. the `swap` account's swap authority.\n\n* `:user_a` - Required. The user's account for token `A`.\n\n* `:user_b` - Required. The user's account for token `B`.\n\n* `:swap_a` - Required. The `swap` account for token `A`.\n\n* `:swap_b` - Required. The `swap` account for token `B`.\n\n* `:user_pool` - Required. The user's account for the pool token. Pool tokens will be deposited here.\n\n* `:pool_mint` - Required. The `swap` pool token's mint.\n\n* `:user_authority` - Required. Account delegated to transfer the user's tokens.\n\n* `:amount_a` (`t:pos_integer/0`) - Required. Maximum amount of token `A` to deposit.\n\n* `:amount_b` (`t:pos_integer/0`) - Required. Maximum amount of token `B` to deposit.\n\n* `:amount_pool` (`t:pos_integer/0`) - Required. Amount of pool tokens to mint.","ref":"Solana.SPL.TokenSwap.html#deposit_all/1-options"},{"type":"function","title":"Solana.SPL.TokenSwap.from_account_info/1","doc":"Translates the result of a `Solana.RPC.Request.get_account_info/2` into\ntoken swap account information.","ref":"Solana.SPL.TokenSwap.html#from_account_info/1"},{"type":"function","title":"Solana.SPL.TokenSwap.id/0","doc":"The Token Swap Program's ID.","ref":"Solana.SPL.TokenSwap.html#id/0"},{"type":"function","title":"Solana.SPL.TokenSwap.init/1","doc":"Creates the instructions to initialize a new token swap account.","ref":"Solana.SPL.TokenSwap.html#init/1"},{"type":"function","title":"Options - Solana.SPL.TokenSwap.init/1","doc":"* `:payer` - Required. The account that will pay for the token swap account creation.\n\n* `:balance` (`t:non_neg_integer/0`) - Required. The lamport balance the token swap account should have.\n\n* `:authority` - Required. The token swap account's swap authority\n\n* `:new` - Required. The public key of the newly-created token swap account.\n\n* `:token_a` - Required. The `A` token account in token swaps. Must be owned by `authority`.\n\n* `:token_b` - Required. The `B` token account in token swaps. Must be owned by `authority`.\n\n* `:pool` - Required. The token account which holds outside liquidity and enables A/B trades.\n\n* `:pool_mint` - Required. The mint of the `pool`.\n\n* `:fee_account` - Required. The token account which receives all trading and withdrawal fees.\n\n* `:trade_fee` - The `new` swap account's trading fee. Trade fees are extra token amounts\n  that are held inside the token accounts during a trade, making the value\n  of liquidity tokens rise. The default value is `{0, 1}`.\n\n* `:owner_trade_fee` - The `new` swap account's owner trading fee. Owner trading fees are extra\n  token amounts that are held inside the token accounts during a trade, with\n  the equivalent in pool tokens minted to the owner of the program. The default value is `{0, 1}`.\n\n* `:owner_withdraw_fee` - The `new` swap account's owner withdraw fee. Owner withdraw fees are extra\n  liquidity pool token amounts that are sent to the owner on every\n  withdrawal. The default value is `{0, 1}`.\n\n* `:host_fee` - The `new` swap account's host fee. Host fees are a proportion of the\n  owner trading fees, sent to an extra account provided during the trade. The default value is `{0, 1}`.\n\n* `:curve` - Required. The automated market maker (AMM) curve to use for the `new` token swap account.\n  Should take the form `{type, params}`. See [the\n  docs](https://spl.solana.com/token-swap#curves) on which curves are available.","ref":"Solana.SPL.TokenSwap.html#init/1-options"},{"type":"function","title":"Solana.SPL.TokenSwap.swap/1","doc":"Creates the instructions to swap token `A` for token `B` or vice versa.","ref":"Solana.SPL.TokenSwap.html#swap/1"},{"type":"function","title":"Options - Solana.SPL.TokenSwap.swap/1","doc":"* `:swap` - Required. The token swap to use.\n\n* `:authority` - Required. the `swap` account's swap authority.\n\n* `:user_source` - Required. User's source token account. Must have the same mint as `swap_source`.\n\n* `:swap_source` - Required. `swap` source token account. Must have the same mint as `user_source`.\n\n* `:user_destination` - Required. User's destination token account. Must have the same mint as `swap_destination`.\n\n* `:swap_destination` - Required. `swap` destination token account. Must have the same mint as `user_destination`.\n\n* `:pool_mint` - Required. The `swap` pool token's mint.\n\n* `:fee_account` - Required. The token account which receives all trading and withdrawal fees.\n\n* `:host_fee_account` - Host account to gather fees.\n\n* `:user_authority` - Required. Account delegated to transfer the user's tokens.\n\n* `:amount` (`t:pos_integer/0`) - Required. Amount to transfer from the source account.\n\n* `:minimum_return` (`t:pos_integer/0`) - Required. Minimum number of tokens the user will receive.","ref":"Solana.SPL.TokenSwap.html#swap/1-options"},{"type":"function","title":"Solana.SPL.TokenSwap.withdraw/1","doc":"Creates the instructions to withdraw `A` or `B` tokens from the pool.","ref":"Solana.SPL.TokenSwap.html#withdraw/1"},{"type":"function","title":"Options - Solana.SPL.TokenSwap.withdraw/1","doc":"* `:swap` - Required. The token swap to use.\n\n* `:authority` - Required. the `swap` account's swap authority.\n\n* `:user_token` - Required. The user's account for token `A` or `B`.\n\n* `:swap_a` - Required. The `swap` account for token `A`.\n\n* `:swap_b` - Required. The `swap` account for token `B`.\n\n* `:user_pool` - Required. The user's account for the pool token. Pool tokens with be withdrawn from here.\n\n* `:pool_mint` - Required. The `swap` pool token's mint.\n\n* `:user_authority` - Required. Account delegated to transfer the user's tokens.\n\n* `:fee_account` - Required. The token account which receives all trading and withdrawal fees.\n\n* `:amount` (`t:pos_integer/0`) - Required. Amount of token `A` or `B` to withdraw.\n\n* `:amount_pool` (`t:pos_integer/0`) - Required. Maximum amount of pool tokens to burn.","ref":"Solana.SPL.TokenSwap.html#withdraw/1-options"},{"type":"function","title":"Solana.SPL.TokenSwap.withdraw_all/1","doc":"Creates the instructions to withdraw both `A` and `B` tokens from the pool.","ref":"Solana.SPL.TokenSwap.html#withdraw_all/1"},{"type":"function","title":"Options - Solana.SPL.TokenSwap.withdraw_all/1","doc":"* `:swap` - Required. The token swap to use.\n\n* `:authority` - Required. the `swap` account's swap authority.\n\n* `:user_a` - Required. The user's account for token `A`.\n\n* `:user_b` - Required. The user's account for token `B`.\n\n* `:swap_a` - Required. The `swap` account for token `A`.\n\n* `:swap_b` - Required. The `swap` account for token `B`.\n\n* `:user_pool` - Required. The user's account for the pool token. Pool tokens with be withdrawn from here.\n\n* `:pool_mint` - Required. The `swap` pool token's mint.\n\n* `:user_authority` - Required. Account delegated to transfer the user's tokens.\n\n* `:fee_account` - Required. The token account which receives all trading and withdrawal fees.\n\n* `:amount_a` (`t:pos_integer/0`) - Required. Minimum amount of token `A` to withdraw.\n\n* `:amount_b` (`t:pos_integer/0`) - Required. Minimum amount of token `B` to withdraw.\n\n* `:amount_pool` (`t:pos_integer/0`) - Required. Amount of pool tokens to burn.","ref":"Solana.SPL.TokenSwap.html#withdraw_all/1-options"},{"type":"module","title":"Solana.RPC","doc":"Functions for dealing with Solana's [JSON-RPC\nAPI](https://docs.solana.com/developing/clients/jsonrpc-api).","ref":"Solana.RPC.html"},{"type":"type","title":"Solana.RPC.client/0","doc":"Solana JSON-RPC API client.","ref":"Solana.RPC.html#t:client/0"},{"type":"function","title":"Solana.RPC.client/1","doc":"Creates an API client used to interact with Solana's [JSON-RPC\nAPI](https://docs.solana.com/developing/clients/jsonrpc-api).","ref":"Solana.RPC.html#client/1"},{"type":"function","title":"Example - Solana.RPC.client/1","doc":"iex> key = Solana.keypair() |> Solana.pubkey!()\n    iex> client = Solana.RPC.client(network: \"localhost\")\n    iex> {:ok, signature} = Solana.RPC.send_request(client, Solana.RPC.Request.request_airdrop(key, 1))\n    iex> is_binary(signature)\n    true","ref":"Solana.RPC.html#client/1-example"},{"type":"function","title":"Options - Solana.RPC.client/1","doc":"* `:adapter` (`t:term/0`) - Which `Tesla` adapter to use. The default value is `Tesla.Adapter.Httpc`.\n\n* `:network` - Required. Which [Solana cluster](https://docs.solana.com/clusters) to connect to.\n\n* `:retry_options` (`t:keyword/0`) - Options to pass to `Tesla.Middleware.Retry`. The default value is `[]`.\n\n* `:headers` (list of tuple of `t:String.t/0`, `t:String.t/0` values) - API headers The default value is `[]`.","ref":"Solana.RPC.html#client/1-options"},{"type":"function","title":"Solana.RPC.send_and_confirm/4","doc":"Sends the provided transactions to the configured RPC endpoint, then confirms them.\n\nReturns a tuple containing all the transactions in the order they were confirmed, OR\nan error tuple containing the list of all the transactions that were confirmed\nbefore the error occurred.","ref":"Solana.RPC.html#send_and_confirm/4"},{"type":"function","title":"Solana.RPC.send_request/2","doc":"Sends the provided requests to the configured Solana RPC endpoint.","ref":"Solana.RPC.html#send_request/2"},{"type":"module","title":"Solana.RPC.Request","doc":"Functions for creating Solana JSON-RPC API requests.\n\nThis client only implements the most common methods (see the function\ndocumentation below). If you need a method that's on the [full\nlist](https://docs.solana.com/developing/clients/jsonrpc-api#json-rpc-api-reference)\nbut is not implemented here, please open an issue or contact the maintainers.","ref":"Solana.RPC.Request.html"},{"type":"function","title":"Solana.RPC.Request.encode/1","doc":"Encodes a `t:Solana.RPC.Request.t/0` (or a list of them) in the [required\nformat](https://docs.solana.com/developing/clients/jsonrpc-api#request-formatting).","ref":"Solana.RPC.Request.html#encode/1"},{"type":"function","title":"Solana.RPC.Request.get_account_info/2","doc":"Returns all information associated with the account of the provided Pubkey.\n\nFor more information, see [the Solana\ndocs](https://docs.solana.com/developing/clients/jsonrpc-api#getaccountinfo).","ref":"Solana.RPC.Request.html#get_account_info/2"},{"type":"function","title":"Solana.RPC.Request.get_balance/2","doc":"Returns the balance of the provided pubkey's account.\n\nFor more information, see [the Solana\ndocs](https://docs.solana.com/developing/clients/jsonrpc-api#getbalance).","ref":"Solana.RPC.Request.html#get_balance/2"},{"type":"function","title":"Solana.RPC.Request.get_block/2","doc":"Returns identity and transaction information about a confirmed block in the\nledger.\n\nFor more information, see [the Solana\ndocs](https://docs.solana.com/developing/clients/jsonrpc-api#getblock).","ref":"Solana.RPC.Request.html#get_block/2"},{"type":"function","title":"Solana.RPC.Request.get_block_height/1","doc":"Returns the current block height of the node\n\nFor more information, see [the Solana\ndocs](https://solana.com/docs/rpc/http/getblockheight).","ref":"Solana.RPC.Request.html#get_block_height/1"},{"type":"function","title":"Solana.RPC.Request.get_fee_for_message/2","doc":"Get the fee the network will charge for a particular Message\n\nFor more information, see [the Solana\ndocs](https://solana.com/docs/rpc/http/getfeeformessage).","ref":"Solana.RPC.Request.html#get_fee_for_message/2"},{"type":"function","title":"Solana.RPC.Request.get_first_available_block/0","doc":"Returns the slot of the lowest confirmed block that has not been purged from the ledger.\n\nFor more information, see [the Solana\ndocs](https://www.quicknode.com/docs/solana/getFirstAvailableBlock).","ref":"Solana.RPC.Request.html#get_first_available_block/0"},{"type":"function","title":"Solana.RPC.Request.get_latest_blockhash/1","doc":"Returns a recent block hash from the ledger, and a fee schedule that can be\nused to compute the cost of submitting a transaction using it.\n\nFor more information, see [the Solana\ndocs](https://docs.solana.com/developing/clients/jsonrpc-api#getrecentblockhash).","ref":"Solana.RPC.Request.html#get_latest_blockhash/1"},{"type":"function","title":"Solana.RPC.Request.get_minimum_balance_for_rent_exemption/2","doc":"Returns minimum balance required to make an account rent exempt.\n\nFor more information, see [the Solana\ndocs](https://docs.solana.com/developing/clients/jsonrpc-api#getminimumbalanceforrentexemption).","ref":"Solana.RPC.Request.html#get_minimum_balance_for_rent_exemption/2"},{"type":"function","title":"Solana.RPC.Request.get_multiple_accounts/2","doc":"Returns the account information for a list of pubkeys.\n\nFor more information, see [the Solana\ndocs](https://docs.solana.com/developing/clients/jsonrpc-api#getmultipleaccounts).","ref":"Solana.RPC.Request.html#get_multiple_accounts/2"},{"type":"function","title":"Solana.RPC.Request.get_signature_statuses/2","doc":"Returns the statuses of a list of signatures.\n\nUnless the `searchTransactionHistory` configuration parameter is included,\nthis method only searches the recent status cache of signatures, which retains\nstatuses for all active slots plus `MAX_RECENT_BLOCKHASHES` rooted slots.\n\nFor more information, see [the Solana\ndocs](https://docs.solana.com/developing/clients/jsonrpc-api#getsignaturestatuses).","ref":"Solana.RPC.Request.html#get_signature_statuses/2"},{"type":"function","title":"Solana.RPC.Request.get_signatures_for_address/2","doc":"Returns confirmed signatures for transactions involving an address backwards\nin time from the provided signature or most recent confirmed block.\n\nFor more information, see [the Solana\ndocs](https://docs.solana.com/developing/clients/jsonrpc-api#getsignaturesforaddress).","ref":"Solana.RPC.Request.html#get_signatures_for_address/2"},{"type":"function","title":"Solana.RPC.Request.get_slot/1","doc":"","ref":"Solana.RPC.Request.html#get_slot/1"},{"type":"function","title":"Solana.RPC.Request.get_token_account_balance/2","doc":"","ref":"Solana.RPC.Request.html#get_token_account_balance/2"},{"type":"function","title":"Solana.RPC.Request.get_token_largest_accounts/2","doc":"Returns the 20 largest accounts of a particular SPL Token type.\n\nFor more information, see [the Solana\ndocs](https://docs.solana.com/developing/clients/jsonrpc-api#gettokenlargestaccounts).","ref":"Solana.RPC.Request.html#get_token_largest_accounts/2"},{"type":"function","title":"Solana.RPC.Request.get_token_supply/2","doc":"Returns the total supply of an SPL Token.\n\nFor more information, see [the Solana\ndocs](https://docs.solana.com/developing/clients/jsonrpc-api#gettokensupply).","ref":"Solana.RPC.Request.html#get_token_supply/2"},{"type":"function","title":"Solana.RPC.Request.get_transaction/2","doc":"Returns transaction details for a confirmed transaction.\n\nFor more information, see [the Solana\ndocs](https://docs.solana.com/developing/clients/jsonrpc-api#gettransaction).","ref":"Solana.RPC.Request.html#get_transaction/2"},{"type":"type","title":"Solana.RPC.Request.json/0","doc":"JSON-RPC API request (JSON encoding)","ref":"Solana.RPC.Request.html#t:json/0"},{"type":"function","title":"Solana.RPC.Request.request_airdrop/3","doc":"Requests an airdrop of lamports to an account.\n\nFor more information, see [the Solana\ndocs](https://docs.solana.com/developing/clients/jsonrpc-api#requestairdrop).","ref":"Solana.RPC.Request.html#request_airdrop/3"},{"type":"function","title":"Solana.RPC.Request.send_transaction/2","doc":"Submits a signed transaction to the cluster for processing.\n\nFor more information, see [the Solana\ndocs](https://docs.solana.com/developing/clients/jsonrpc-api#sendtransaction).","ref":"Solana.RPC.Request.html#send_transaction/2"},{"type":"type","title":"Solana.RPC.Request.t/0","doc":"JSON-RPC API request (pre-encoding)","ref":"Solana.RPC.Request.html#t:t/0"},{"type":"module","title":"Solana.RPC.Tracker","doc":"A GenServer you can use to track the status of transaction signatures.","ref":"Solana.RPC.Tracker.html"},{"type":"module","title":"Example - Solana.RPC.Tracker","doc":"iex> key = Solana.keypair() |> Solana.pubkey!()\n    iex> {:ok, tracker} = Solana.RPC.Tracker.start_link(network: \"localhost\")\n    iex> client = Solana.RPC.client(network: \"localhost\")\n    iex> {:ok, tx} = Solana.RPC.send_request(client, Solana.RPC.Request.request_airdrop(key, 1))\n    iex> Solana.Tracker.start_tracking(tracker, tx)\n    iex> receive do\n    ...>   {:ok, [^tx]} -> IO.puts(\"confirmed!\")\n    ...> end\n    confirmed!","ref":"Solana.RPC.Tracker.html#module-example"},{"type":"function","title":"Solana.RPC.Tracker.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Solana.RPC.Tracker.html#child_spec/1"},{"type":"function","title":"Solana.RPC.Tracker.start_link/1","doc":"Starts a `Solana.RPC.Tracker` process linked to the current process.","ref":"Solana.RPC.Tracker.html#start_link/1"},{"type":"function","title":"Solana.RPC.Tracker.start_tracking/3","doc":"Starts tracking a transaction signature or list of transaction signatures.\n\nSends messages back to the calling process as transactions from the list\nare confirmed. Stops tracking automatically once transactions have been\nconfirmed.","ref":"Solana.RPC.Tracker.html#start_tracking/3"},{"type":"module","title":"Solana.Account","doc":"Functions, types, and structures related to Solana\n[accounts](https://docs.solana.com/developing/programming-model/accounts).","ref":"Solana.Account.html"},{"type":"type","title":"Solana.Account.t/0","doc":"All the information needed to encode an account in a transaction message.","ref":"Solana.Account.html#t:t/0"},{"type":"module","title":"Solana.Instruction","doc":"Functions, types, and structures related to Solana\n[instructions](https://docs.solana.com/developing/programming-model/transactions#instructions).","ref":"Solana.Instruction.html"},{"type":"type","title":"Solana.Instruction.t/0","doc":"All the details needed to encode an instruction.","ref":"Solana.Instruction.html#t:t/0"},{"type":"module","title":"Solana.Key","doc":"Functions for creating and validating Solana\n[keys](https://docs.solana.com/terminology#public-key-pubkey) and\n[keypairs](https://docs.solana.com/terminology#keypair).","ref":"Solana.Key.html"},{"type":"function","title":"Solana.Key.check/1","doc":"Checks to see if a `t:Solana.Key.t/0` is valid.","ref":"Solana.Key.html#check/1"},{"type":"function","title":"Solana.Key.decode/1","doc":"decodes a base58-encoded key and returns it in a tuple.\n\nIf it fails, return an error tuple.","ref":"Solana.Key.html#decode/1"},{"type":"function","title":"Solana.Key.decode!/1","doc":"decodes a base58-encoded key and returns it.\n\nThrows an `ArgumentError` if it fails.","ref":"Solana.Key.html#decode!/1"},{"type":"function","title":"Solana.Key.derive_address/2","doc":"Derives a program address from seeds and a program ID.","ref":"Solana.Key.html#derive_address/2"},{"type":"function","title":"Solana.Key.find_address/2","doc":"Finds a valid program address.\n\nValid addresses must fall off the ed25519 curve; generate a series of nonces,\nthen combine each one with the given seeds and program ID until a valid\naddress is found. If a valid address is found, return the address and the\nnonce in a tuple. Otherwise, return an error tuple.","ref":"Solana.Key.html#find_address/2"},{"type":"function","title":"Solana.Key.pair/0","doc":"Generates a public/private key pair in the format `{private_key, public_key}`","ref":"Solana.Key.html#pair/0"},{"type":"type","title":"Solana.Key.pair/0","doc":"a public/private keypair","ref":"Solana.Key.html#t:pair/0"},{"type":"function","title":"Solana.Key.pair_from_file/1","doc":"Reads a public/private key pair from a [file system\nwallet](https://docs.solana.com/wallet-guide/file-system-wallet) in the format\n`{private_key, public_key}`. Returns `{:ok, pair}` if successful, or `{:error,\nreason}` if not.","ref":"Solana.Key.html#pair_from_file/1"},{"type":"type","title":"Solana.Key.t/0","doc":"Solana public or private key","ref":"Solana.Key.html#t:t/0"},{"type":"function","title":"Solana.Key.with_seed/3","doc":"Derive a public key from another key, a seed, and a program ID.\n\nThe program ID will also serve as the owner of the public key, giving it\npermission to write data to the account.","ref":"Solana.Key.html#with_seed/3"},{"type":"module","title":"Solana.Transaction","doc":"Functions for building and encoding Solana\n[transactions](https://docs.solana.com/developing/programming-model/transactions)","ref":"Solana.Transaction.html"},{"type":"function","title":"Solana.Transaction.check/1","doc":"Checks to see if a transaction's signature is valid.\n\nReturns `{:ok, signature}` if it is, and an error tuple if it isn't.","ref":"Solana.Transaction.html#check/1"},{"type":"function","title":"Solana.Transaction.decode/1","doc":"decodes a base58-encoded signature and returns it in a tuple.\n\nIf it fails, return an error tuple.","ref":"Solana.Transaction.html#decode/1"},{"type":"function","title":"Solana.Transaction.decode!/1","doc":"decodes a base58-encoded signature and returns it.\n\nThrows an `ArgumentError` if it fails.","ref":"Solana.Transaction.html#decode!/1"},{"type":"function","title":"Solana.Transaction.encode_message/1","doc":"","ref":"Solana.Transaction.html#encode_message/1"},{"type":"type","title":"Solana.Transaction.encoding_err/0","doc":"The possible errors encountered when encoding a transaction.","ref":"Solana.Transaction.html#t:encoding_err/0"},{"type":"function","title":"Solana.Transaction.parse/1","doc":"Parses a `t:Solana.Transaction.t/0` from data encoded in Solana's [binary\nformat](https://docs.solana.com/developing/programming-model/transactions#anatomy-of-a-transaction)\n\nReturns `{transaction, extras}` if the transaction was successfully\nparsed, or `:error` if the provided binary could not be parsed. `extras`\nis a keyword list containing information about the encoded transaction,\nnamely:\n\n- `:header` - the [transaction message\nheader](https://docs.solana.com/developing/programming-model/transactions#message-header-format)\n- `:accounts` - an [ordered array of\naccounts](https://docs.solana.com/developing/programming-model/transactions#account-addresses-format)\n- `:signatures` - a [list of signed copies of the transaction\nmessage](https://docs.solana.com/developing/programming-model/transactions#signatures)","ref":"Solana.Transaction.html#parse/1"},{"type":"type","title":"Solana.Transaction.t/0","doc":"All the details needed to encode a transaction.","ref":"Solana.Transaction.html#t:t/0"},{"type":"function","title":"Solana.Transaction.to_binary/1","doc":"Encodes a `t:Solana.Transaction.t/0` into a [binary\nformat](https://docs.solana.com/developing/programming-model/transactions#anatomy-of-a-transaction)\n\nReturns `{:ok, encoded_transaction}` if the transaction was successfully\nencoded, or an error tuple if the encoding failed -- plus more error details\nvia `Logger.error/1`.","ref":"Solana.Transaction.html#to_binary/1"},{"type":"module","title":"Solana.SystemProgram","doc":"Functions for interacting with Solana's [System\nProgram](https://docs.solana.com/developing/runtime-facilities/programs#system-program)","ref":"Solana.SystemProgram.html"},{"type":"function","title":"Solana.SystemProgram.allocate/1","doc":"Generates instructions to allocate space to an account.\n\nAccepts an `account` address generated via `Solana.Key.with_seed/3`, as long\nas the `base` key, `program_id`, and `seed` used to generate that address are\nprovided.","ref":"Solana.SystemProgram.html#allocate/1"},{"type":"function","title":"Options - Solana.SystemProgram.allocate/1","doc":"* `:account` - Required. Public key for the account to allocate\n\n* `:space` (`t:non_neg_integer/0`) - Required. Amount of space in bytes to allocate\n\n* `:program_id` - Program ID to assign as the owner of the allocated account\n\n* `:base` - Base public key to use to derive the allocated account address\n\n* `:seed` (`t:String.t/0`) - Seed to use to derive the allocated account address","ref":"Solana.SystemProgram.html#allocate/1-options"},{"type":"function","title":"Solana.SystemProgram.assign/1","doc":"Generates instructions to assign account ownership to a program.\n\nAccepts an `account` address generated via `Solana.Key.with_seed/3`, as long\nas the `base` key and `seed` used to generate that address are provided.","ref":"Solana.SystemProgram.html#assign/1"},{"type":"function","title":"Options - Solana.SystemProgram.assign/1","doc":"* `:account` - Required. Public key for the account which will receive a new owner\n\n* `:program_id` - Required. Program ID to assign as the owner\n\n* `:base` - Base public key to use to derive the assigned account address\n\n* `:seed` (`t:String.t/0`) - Seed to use to derive the assigned account address","ref":"Solana.SystemProgram.html#assign/1-options"},{"type":"function","title":"Solana.SystemProgram.create_account/1","doc":"Generates instructions to create a new account.\n\nAccepts a `new` address generated via `Solana.Key.with_seed/3`, as long as the\n`base` key and `seed` used to generate that address are provided.","ref":"Solana.SystemProgram.html#create_account/1"},{"type":"function","title":"Options - Solana.SystemProgram.create_account/1","doc":"* `:lamports` (`t:pos_integer/0`) - Required. Amount of lamports to transfer to the created account\n\n* `:space` (`t:non_neg_integer/0`) - Required. Amount of space in bytes to allocate to the created account\n\n* `:from` - Required. The account that will transfer lamports to the created account\n\n* `:new` - Required. Public key of the created account\n\n* `:program_id` - Required. Public key of the program which will own the created account\n\n* `:base` - Base public key to use to derive the created account's address\n\n* `:seed` (`t:String.t/0`) - Seed to use to derive the created account's address","ref":"Solana.SystemProgram.html#create_account/1-options"},{"type":"function","title":"Solana.SystemProgram.id/0","doc":"The System Program's program ID.","ref":"Solana.SystemProgram.html#id/0"},{"type":"function","title":"Solana.SystemProgram.transfer/1","doc":"Generates instructions to transfer lamports from one account to another.\n\nAccepts a `from` address generated via `Solana.Key.with_seed/3`, as long as the\n`base` key, `program_id`, and `seed` used to generate that address are\nprovided.","ref":"Solana.SystemProgram.html#transfer/1"},{"type":"function","title":"Options - Solana.SystemProgram.transfer/1","doc":"* `:lamports` (`t:pos_integer/0`) - Required. Amount of lamports to transfer\n\n* `:from` - Required. Account that will transfer lamports\n\n* `:to` - Required. Account that will receive the transferred lamports\n\n* `:base` - Base public key to use to derive the funding account address\n\n* `:seed` (`t:String.t/0`) - Seed to use to derive the funding account address\n\n* `:program_id` - Program ID to use to derive the funding account address","ref":"Solana.SystemProgram.html#transfer/1-options"},{"type":"module","title":"Solana.SystemProgram.Nonce","doc":"Functions for interacting with the [System\nProgram](https://docs.solana.com/developing/runtime-facilities/programs#system-program)'s\nnonce accounts, required for [durable transaction\nnonces](https://docs.solana.com/offline-signing/durable-nonce).\n\nThese accounts can be useful for offline transactions, as well as transactions\nthat require more time to generate a transaction signature than the normal\n`recent_blockhash` transaction mechanism gives them (~2 minutes).","ref":"Solana.SystemProgram.Nonce.html"},{"type":"function","title":"Solana.SystemProgram.Nonce.advance/1","doc":"Generates the instructions for advancing a nonce account's stored nonce value.","ref":"Solana.SystemProgram.Nonce.html#advance/1"},{"type":"function","title":"Options - Solana.SystemProgram.Nonce.advance/1","doc":"* `:nonce` - Required. Public key of the nonce account\n\n* `:authority` - Required. Public key of the nonce authority","ref":"Solana.SystemProgram.Nonce.html#advance/1-options"},{"type":"function","title":"Solana.SystemProgram.Nonce.authorize/1","doc":"Generates the instructions for re-assigning the authority of a nonce account.","ref":"Solana.SystemProgram.Nonce.html#authorize/1"},{"type":"function","title":"Options - Solana.SystemProgram.Nonce.authorize/1","doc":"* `:nonce` - Required. Public key of the nonce account\n\n* `:authority` - Required. Public key of the nonce authority\n\n* `:new_authority` - Required. Public key to set as the new nonce authority","ref":"Solana.SystemProgram.Nonce.html#authorize/1-options"},{"type":"function","title":"Solana.SystemProgram.Nonce.byte_size/0","doc":"The size of a serialized nonce account.","ref":"Solana.SystemProgram.Nonce.html#byte_size/0"},{"type":"function","title":"Solana.SystemProgram.Nonce.from_account_info/1","doc":"Translates the result of a `Solana.RPC.Request.get_account_info/2` into a\nnonce account's information.","ref":"Solana.SystemProgram.Nonce.html#from_account_info/1"},{"type":"function","title":"Solana.SystemProgram.Nonce.init/1","doc":"Generates the instructions for initializing a nonce account.","ref":"Solana.SystemProgram.Nonce.html#init/1"},{"type":"function","title":"Options - Solana.SystemProgram.Nonce.init/1","doc":"* `:nonce` - Required. Public key of the nonce account\n\n* `:authority` - Required. Public key of the nonce authority","ref":"Solana.SystemProgram.Nonce.html#init/1-options"},{"type":"function","title":"Solana.SystemProgram.Nonce.withdraw/1","doc":"Generates the instructions for withdrawing funds form a nonce account.","ref":"Solana.SystemProgram.Nonce.html#withdraw/1"},{"type":"function","title":"Options - Solana.SystemProgram.Nonce.withdraw/1","doc":"* `:nonce` - Required. Public key of the nonce account\n\n* `:authority` - Required. Public key of the nonce authority\n\n* `:to` - Required. Public key of the account which will get the withdrawn lamports\n\n* `:lamports` (`t:pos_integer/0`) - Required. Amount of lamports to transfer to the created account","ref":"Solana.SystemProgram.Nonce.html#withdraw/1-options"},{"type":"module","title":"Solana.TestValidator","doc":"A [Solana Test Validator](https://docs.solana.com/developing/test-validator)\nmanaged by an Elixir process. This allows you to run unit tests as if you had\nthe `solana-test-validator` tool running in another process.","ref":"Solana.TestValidator.html"},{"type":"module","title":"Requirements - Solana.TestValidator","doc":"Since `Solana.TestValidator` uses the `solana-test-validator` binary, you'll\nneed to have the [Solana tool\nsuite](https://docs.solana.com/cli/install-solana-cli-tools) installed.","ref":"Solana.TestValidator.html#module-requirements"},{"type":"module","title":"How to Use - Solana.TestValidator","doc":"You can use the `Solana.TestValidator` directly or in a supervision tree.\n\nTo use it directly, add the following lines to the beginning of your\n`test/test_helper.exs` file:\n\n```elixir\nalias Solana.TestValidator\n{:ok, validator} = TestValidator.start_link(ledger: \"/tmp/test-ledger\")\nExUnit.after_suite(fn _ -> TestValidator.stop(validator) end)\n```\n\nThis will start and stop the `solana-test-validator` before and after your\ntests run.","ref":"Solana.TestValidator.html#module-how-to-use"},{"type":"module","title":"In a supervision tree - Solana.TestValidator","doc":"Alternatively, you can add it to your application's supervision tree during\ntests. Modify your `mix.exs` file to make the current environment available to\nyour application:\n\n```elixir\ndef application do\n  [mod: {MyApp, env: Mix.env()}]\nend\n```\n\nThen, adjust your application's `children` depending on the environment:\n\n```elixir\ndefmodule MyApp do\n  use Application\n\n  def start(_type, env: env) do\n    Supervisor.start_link(children(env), strategy: :one_for_one)\n  end\n\n  defp children(:test) do\n    [\n      {Solana.TestValidator, ledger: \"/tmp/test_ledger\"},\n      # ... other children\n    ]\n  end\n\n  defp children(_) do\n    # ...other children\n  end\nend\n```","ref":"Solana.TestValidator.html#module-in-a-supervision-tree"},{"type":"module","title":"Options - Solana.TestValidator","doc":"You can pass any of the **long-form** options you would pass to a\n`solana-test-validator` here.\n\nFor example, to add your own program to the validator, set the `bpf_program`\noption as the path to your program's [build\nartifact](https://docs.solana.com/developing/on-chain-programs/developing-rust#how-to-build).\nSee `Solana.TestValidator.start_link/1` for more details.","ref":"Solana.TestValidator.html#module-options"},{"type":"function","title":"Solana.TestValidator.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"Solana.TestValidator.html#child_spec/1"},{"type":"function","title":"Solana.TestValidator.get_state/1","doc":"Gets the state of a `Solana.TestValidator` process.\n\nThis is useful when you want to check the latest output of the\n`solana-test-validator`.","ref":"Solana.TestValidator.html#get_state/1"},{"type":"function","title":"Solana.TestValidator.start_link/1","doc":"Starts a `Solana.TestValidator` process linked to the current process.\n\nThis process runs and monitors a `solana-test-validator` in the background.","ref":"Solana.TestValidator.html#start_link/1"},{"type":"function","title":"Options - Solana.TestValidator.start_link/1","doc":"* `:bind_address` (`t:String.t/0`) - The default value is `\"0.0.0.0\"`.\n\n* `:bpf_program`\n\n* `:clone`\n\n* `:config` (`t:String.t/0`) - The default value is `\"/home/ayrat/.config/solana/cli/config.yml\"`.\n\n* `:dynamic_port_range` (`t:String.t/0`) - The default value is `\"1024-65535\"`.\n\n* `:faucet_port` (`t:pos_integer/0`) - The default value is `9900`.\n\n* `:faucet_sol` (`t:pos_integer/0`) - The default value is `1000000`.\n\n* `:gossip_host` (`t:String.t/0`) - The default value is `\"127.0.0.1\"`.\n\n* `:gossip_port` (`t:pos_integer/0`)\n\n* `:url` (`t:String.t/0`)\n\n* `:ledger` (`t:String.t/0`) - The default value is `\"test-ledger\"`.\n\n* `:limit_ledger_size` (`t:pos_integer/0`) - The default value is `10000`.\n\n* `:mint`\n\n* `:rpc_port` (`t:pos_integer/0`) - The default value is `8899`.\n\n* `:slots_per_epoch` (`t:pos_integer/0`)\n\n* `:warp_slot` (`t:String.t/0`)","ref":"Solana.TestValidator.html#start_link/1-options"},{"type":"function","title":"Solana.TestValidator.stop/1","doc":"Stops a `Solana.TestValidator` process.\n\nShould be called when you want to stop the `solana-test-validator`.","ref":"Solana.TestValidator.html#stop/1"},{"type":"extras","title":"Solana","doc":"# Solana\n\nThe unofficial Elixir package for interacting with the\n[Solana](https://solana.com) blockchain.\n\n> Note that this README refers to the master branch of `solana`, not the latest\n> released version on Hex. See [the documentation](https://hexdocs.pm/solana)\n> for the documentation of the version you're using.","ref":"readme.html"},{"type":"extras","title":"Installation - Solana","doc":"Add `solana` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:solana, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation"},{"type":"extras","title":"Documentation - Solana","doc":"- [JSON-RPC API client](#json-rpc-api-client)\n  - [Using a custom HTTP client](#using-a-custom-http-client)\n- [On-chain program interaction](#solana-program-interaction)\n- [Writing a custom program client](#writing-a-custom-program-client)\n  - [Testing custom programs](#testing-custom-programs)","ref":"readme.html#documentation"},{"type":"extras","title":"JSON-RPC API Client - Solana","doc":"`solana` provides a simple interface for interacting with Solana's [JSON-RPC\nAPI](https://docs.solana.com/developing/clients/jsonrpc-api). Here's an example\nof requesting an airdrop to a new Solana account via the `requestAirdrop`\nmethod:\n\n```elixir\nkey = Solana.keypair() |> Solana.pubkey!()\nclient = Solana.RPC.client(network: \"localhost\")\n{:ok, signature} = Solana.RPC.send_request(client, Solana.RPC.Request.request_airdrop(key, 1))\n\nSolana.Transaction.check(signature) # {:ok, ^signature}\n```\n\nTo see the full list of supported methods, check the `Solana.RPC.Request`\nmodule.","ref":"readme.html#json-rpc-api-client"},{"type":"extras","title":"Using a custom HTTP client - Solana","doc":"Since this module uses `Tesla` for its API client, you can use whichever\nHTTP client you wish, just be sure to include it in your dependencies:\n\n```elixir\ndef deps do\n  [\n    # Gun, for example\n    {:gun, \"~> 1.3\"},\n    {:idna, \"~> 6.0\"},\n    {:castore, \"~> 0.1\"},\n    # SSL verification\n    {:ssl_verify_hostname, \"~> 1.0\"},\n  ]\nend\n```\n\nThen, specify the corresponding `Tesla.Adapter` when creating your client:\n\n```elixir\nclient = Solana.RPC.client(network: \"localhost\", adapter: {Tesla.Adapter.Gun, certificates_verification: true})\n```\n\nSee the `Solana.RPC` module for more details about which options are available\nwhen creating an API client.","ref":"readme.html#using-a-custom-http-client"},{"type":"extras","title":"On-chain program interaction - Solana","doc":"Since `solana`'s JSON-RPC API client supports `sendTransaction`, you can use it\nto interact with on-chain Solana programs. `solana` provides utilities to craft\ntransactions, send them, and confirm them on-chain. It also includes the\n`Solana.SystemProgram` module, which allows you to create\n[SystemProgram](https://docs.solana.com/developing/runtime-facilities/programs#system-program)\ninstructions.\n\nAlso check out the `solana_spl` package\n[documentation](https://hexdocs.pm/solana_spl) to interact with the [Solana\nProgram Library](https://spl.solana.com).","ref":"readme.html#on-chain-program-interaction"},{"type":"extras","title":"Writing a custom program client - Solana","doc":"By providing an interface for the `Solana.SystemProgram`, `solana` provides\nguidelines for how to build interfaces to your own programs. For more examples,\nsee the [`solana_spl` package](https://hexdocs.pm/solana_spl).","ref":"readme.html#writing-a-custom-program-client"},{"type":"extras","title":"Testing custom programs - Solana","doc":"Once you've built your custom program's client, you should probably write some\ntests for it. `solana` provides example tests for the `Solana.SystemProgram` in\n`test/solana/system_program_test.exs`, along with an Elixir-managed [Solana Test\nValidator](https://docs.solana.com/developing/test-validator) process to test\nyour program locally. See `Solana.TestValidator` for more details about how to\nset this up.","ref":"readme.html#testing-custom-programs"},{"type":"extras","title":"LICENSE","doc":"Copyright © 2021 Derek Meer\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the “Software”), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}